from collections.abc import Mapping
from typing import TYPE_CHECKING, Any, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.v0042_tres import V0042Tres


T = TypeVar("T", bound="V0042JobTres")


@_attrs_define
class V0042JobTres:
    """
    Attributes:
        allocated (Union[Unset, list['V0042Tres']]):
        requested (Union[Unset, list['V0042Tres']]):
    """

    allocated: Union[Unset, list["V0042Tres"]] = UNSET
    requested: Union[Unset, list["V0042Tres"]] = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        allocated: Union[Unset, list[dict[str, Any]]] = UNSET
        if not isinstance(self.allocated, Unset):
            allocated = []
            for componentsschemasv0_0_42_tres_list_item_data in self.allocated:
                componentsschemasv0_0_42_tres_list_item = componentsschemasv0_0_42_tres_list_item_data.to_dict()
                allocated.append(componentsschemasv0_0_42_tres_list_item)

        requested: Union[Unset, list[dict[str, Any]]] = UNSET
        if not isinstance(self.requested, Unset):
            requested = []
            for componentsschemasv0_0_42_tres_list_item_data in self.requested:
                componentsschemasv0_0_42_tres_list_item = componentsschemasv0_0_42_tres_list_item_data.to_dict()
                requested.append(componentsschemasv0_0_42_tres_list_item)

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if allocated is not UNSET:
            field_dict["allocated"] = allocated
        if requested is not UNSET:
            field_dict["requested"] = requested

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        from ..models.v0042_tres import V0042Tres

        d = dict(src_dict)
        allocated = []
        _allocated = d.pop("allocated", UNSET)
        for componentsschemasv0_0_42_tres_list_item_data in _allocated or []:
            componentsschemasv0_0_42_tres_list_item = V0042Tres.from_dict(componentsschemasv0_0_42_tres_list_item_data)

            allocated.append(componentsschemasv0_0_42_tres_list_item)

        requested = []
        _requested = d.pop("requested", UNSET)
        for componentsschemasv0_0_42_tres_list_item_data in _requested or []:
            componentsschemasv0_0_42_tres_list_item = V0042Tres.from_dict(componentsschemasv0_0_42_tres_list_item_data)

            requested.append(componentsschemasv0_0_42_tres_list_item)

        v0042_job_tres = cls(
            allocated=allocated,
            requested=requested,
        )

        v0042_job_tres.additional_properties = d
        return v0042_job_tres

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
