from collections.abc import Mapping
from typing import Any, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="V0042PartitionInfoNodes")


@_attrs_define
class V0042PartitionInfoNodes:
    """
    Attributes:
        allowed_allocation (Union[Unset, str]): AllocNodes
        configured (Union[Unset, str]): Nodes
        total (Union[Unset, int]): TotalNodes
    """

    allowed_allocation: Union[Unset, str] = UNSET
    configured: Union[Unset, str] = UNSET
    total: Union[Unset, int] = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        allowed_allocation = self.allowed_allocation

        configured = self.configured

        total = self.total

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if allowed_allocation is not UNSET:
            field_dict["allowed_allocation"] = allowed_allocation
        if configured is not UNSET:
            field_dict["configured"] = configured
        if total is not UNSET:
            field_dict["total"] = total

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        allowed_allocation = d.pop("allowed_allocation", UNSET)

        configured = d.pop("configured", UNSET)

        total = d.pop("total", UNSET)

        v0042_partition_info_nodes = cls(
            allowed_allocation=allowed_allocation,
            configured=configured,
            total=total,
        )

        v0042_partition_info_nodes.additional_properties = d
        return v0042_partition_info_nodes

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
